DevExtreme v25.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Charts - Colorization

This demo shows options that you can use to colorize TreeMap tiles. To see each option, use the drop-down editor below the component.

Backend API
$(() => { const colorizationOptions = [{ name: 'Discrete', options: { type: 'discrete', palette: 'harmony light', colorizeGroups: false, }, }, { name: 'Grouped', options: { type: 'discrete', palette: 'harmony light', colorizeGroups: true, }, }, { name: 'Range', options: { type: 'range', palette: ['#fbd600', '#78299a'], range: [0, 50000, 100000, 150000, 200000, 250000], colorCodeField: 'salesAmount', colorizeGroups: false, }, }, { name: 'Gradient', options: { type: 'gradient', palette: ['#fbd600', '#78299a'], range: [10000, 250000], colorCodeField: 'salesAmount', colorizeGroups: false, }, }]; const startColorization = colorizationOptions[2]; const treeMap = $('#treemap').dxTreeMap({ dataSource: salesAmount, title: 'Sales Amount by Product', valueField: 'salesAmount', tooltip: { enabled: true, format: 'currency', customizeTooltip(arg) { const { data } = arg.node; return { text: arg.node.isLeaf() ? (`<span class='product'>${data.name }</span><br/>Sales Amount: ${arg.valueText}`) : null, }; }, }, colorizer: startColorization.options, }).dxTreeMap('instance'); $('#colorization').dxSelectBox({ items: colorizationOptions, width: 200, inputAttr: { 'aria-label': 'Colorization Option' }, value: startColorization, displayExpr: 'name', onValueChanged(data) { treeMap.option('colorizer', data.value.options); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="treemap"></div> <div class="options"> <div class="caption">Options</div> <div class="option"> <span>Colorization Type</span> <div id="colorization" class="selectbox"></div> </div> </div> </div> </body> </html>
.product { font-weight: 500; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); margin-top: 20px; } .option { margin-top: 10px; } .caption { font-size: 18px; font-weight: 500; } .option > span { margin-right: 10px; } .option > .dx-widget { display: inline-block; vertical-align: middle; }
const salesAmount = [{ name: 'Monitors', items: [{ name: 'DesktopLCD 19', salesAmount: 23420, }, { name: 'DesktopLCD 21', salesAmount: 113900, }, { name: 'DesktopLED 19', salesAmount: 49170, }, { name: 'DesktopLED 21', salesAmount: 81200, }], }, { name: 'Projectors', items: [{ name: 'Projector Plus', salesAmount: 99000, }, { name: 'Projector PlusHD', salesAmount: 152250, }], }, { name: 'Televisions', items: [{ name: 'SuperLCD 55', salesAmount: 147150, }, { name: 'SuperLCD 42', salesAmount: 103200, }, { name: 'SuperLCD 70', salesAmount: 56000, }, { name: 'SuperLED 42', salesAmount: 159500, }, { name: 'SuperLED 50', salesAmount: 233600, }, { name: 'SuperPlasma 50', salesAmount: 184800, }, { name: 'SuperPlasma 65', salesAmount: 178500, }], }, { name: 'Video Players', items: [{ name: 'HD Video Player', salesAmount: 63690, }, { name: 'SuperHD Video Player', salesAmount: 74000, }], }];

To colorize the TreeMap tiles, you can use the colorizer object. This object allows you to specify the colorization type:

  • "discrete" (default)
    This colorization algorithm paints each tile within a group in a color from the palette. When there are multiple groups, the way in which groups are colorized depends on the colorizeGroups property setting:

    • If colorizeGroups is set to false (Discrete mode in the demo):
      Each group is painted independently - regardless of the colors used in other groups.

    • If colorizeGroups is set to true (Grouped mode in the demo):
      Each group is painted with a different color from the palette.

  • "gradient"
    If you choose this algorithm, the palette should contain only two colors that the component uses to colorize the smallest and the largest tile, respectively. The other tiles will have a tint of either the first or the second color depending on their size. In order to use the "gradient" algorithm, you need to set the range property to an array of only two values.

  • "range"
    This algorithm is similar to "gradient", but the array assigned to the range property should contain more than two values. This array specifies the ranges between each value. The palette of two colors will generate multiple tints - one for each range.

If you use the "gradient" or "range" colorization algorithm, the color of the tile depends on the value. Normally, the value field supplies this value to the component. However, you can use the colorCodeField property to assign another field to supply the value.

import React, { useCallback, useState } from 'react';
import TreeMap, { Tooltip } from 'devextreme-react/tree-map';
import type { ITooltipProps } from 'devextreme-react/tree-map';
import SelectBox, { type SelectBoxTypes } from 'devextreme-react/select-box';
import { salesAmount, colorizationOptions, colorizationTypeLabel } from './data.ts';
const customizeTooltip: ITooltipProps['customizeTooltip'] = (arg) => {
const { data } = arg.node;
return {
text: arg.node.isLeaf() ? `<span class='product'>${data.name}</span><br/>Sales Amount: ${arg.valueText}` : null,
};
};
function App() {
const [typeOptions, setTypeOptions] = useState(colorizationOptions[2].options);
const setType = useCallback((data: SelectBoxTypes.ValueChangedEvent) => {
setTypeOptions(data.value);
}, [setTypeOptions]);
return (
<>
<TreeMap
id="treemap"
dataSource={salesAmount}
title="Sales Amount by Product"
valueField="salesAmount"
colorizer={typeOptions}
>
<Tooltip
enabled={true}
customizeTooltip={customizeTooltip}
format="currency"
/>
</TreeMap>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Colorization Type </span>
<SelectBox
dataSource={colorizationOptions}
displayExpr="name"
inputAttr={colorizationTypeLabel}
valueExpr="options"
width={200}
value={typeOptions}
onValueChanged={setType}
/>
</div>
</div>
</>
);
}
export default App;
import React, { useCallback, useState } from 'react';
import TreeMap, { Tooltip } from 'devextreme-react/tree-map';
import SelectBox from 'devextreme-react/select-box';
import { salesAmount, colorizationOptions, colorizationTypeLabel } from './data.js';
const customizeTooltip = (arg) => {
const { data } = arg.node;
return {
text: arg.node.isLeaf()
? `<span class='product'>${data.name}</span><br/>Sales Amount: ${arg.valueText}`
: null,
};
};
function App() {
const [typeOptions, setTypeOptions] = useState(colorizationOptions[2].options);
const setType = useCallback(
(data) => {
setTypeOptions(data.value);
},
[setTypeOptions],
);
return (
<>
<TreeMap
id="treemap"
dataSource={salesAmount}
title="Sales Amount by Product"
valueField="salesAmount"
colorizer={typeOptions}
>
<Tooltip
enabled={true}
customizeTooltip={customizeTooltip}
format="currency"
/>
</TreeMap>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Colorization Type </span>
<SelectBox
dataSource={colorizationOptions}
displayExpr="name"
inputAttr={colorizationTypeLabel}
valueExpr="options"
width={200}
value={typeOptions}
onValueChanged={setType}
/>
</div>
</div>
</>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { Properties as TreeMapPropType } from 'devextreme/viz/tree_map';
type typeOptionsType = TreeMapPropType['colorizer'];
export const colorizationOptions: { name: string, options: typeOptionsType }[] = [{
name: 'Discrete',
options: {
type: 'discrete',
palette: 'Harmony Light',
colorizeGroups: false,
},
}, {
name: 'Grouped',
options: {
type: 'discrete',
palette: 'Harmony Light',
colorizeGroups: true,
},
}, {
name: 'Range',
options: {
type: 'range',
palette: ['#fbd600', '#78299a'],
range: [0, 50000, 100000, 150000, 200000, 250000],
colorCodeField: 'salesAmount',
colorizeGroups: false,
},
}, {
name: 'Gradient',
options: {
type: 'gradient',
palette: ['#fbd600', '#78299a'],
range: [10000, 250000],
colorCodeField: 'salesAmount',
colorizeGroups: false,
},
}];
export const salesAmount = [{
name: 'Monitors',
items: [{
name: 'DesktopLCD 19',
salesAmount: 23420,
}, {
name: 'DesktopLCD 21',
salesAmount: 113900,
}, {
name: 'DesktopLED 19',
salesAmount: 49170,
}, {
name: 'DesktopLED 21',
salesAmount: 81200,
}],
}, {
name: 'Projectors',
items: [{
name: 'Projector Plus',
salesAmount: 99000,
}, {
name: 'Projector PlusHD',
salesAmount: 152250,
}],
}, {
name: 'Televisions',
items: [{
name: 'SuperLCD 55',
salesAmount: 147150,
}, {
name: 'SuperLCD 42',
salesAmount: 103200,
}, {
name: 'SuperLCD 70',
salesAmount: 56000,
}, {
name: 'SuperLED 42',
salesAmount: 159500,
}, {
name: 'SuperLED 50',
salesAmount: 233600,
}, {
name: 'SuperPlasma 50',
salesAmount: 184800,
}, {
name: 'SuperPlasma 65',
salesAmount: 178500,
}],
}, {
name: 'Video Players',
items: [{
name: 'HD Video Player',
salesAmount: 63690,
}, {
name: 'SuperHD Video Player',
salesAmount: 74000,
}],
}];
export const colorizationTypeLabel = { 'aria-label': 'Colorization Type' };
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const colorizationOptions = [
{
name: 'Discrete',
options: {
type: 'discrete',
palette: 'Harmony Light',
colorizeGroups: false,
},
},
{
name: 'Grouped',
options: {
type: 'discrete',
palette: 'Harmony Light',
colorizeGroups: true,
},
},
{
name: 'Range',
options: {
type: 'range',
palette: ['#fbd600', '#78299a'],
range: [0, 50000, 100000, 150000, 200000, 250000],
colorCodeField: 'salesAmount',
colorizeGroups: false,
},
},
{
name: 'Gradient',
options: {
type: 'gradient',
palette: ['#fbd600', '#78299a'],
range: [10000, 250000],
colorCodeField: 'salesAmount',
colorizeGroups: false,
},
},
];
export const salesAmount = [
{
name: 'Monitors',
items: [
{
name: 'DesktopLCD 19',
salesAmount: 23420,
},
{
name: 'DesktopLCD 21',
salesAmount: 113900,
},
{
name: 'DesktopLED 19',
salesAmount: 49170,
},
{
name: 'DesktopLED 21',
salesAmount: 81200,
},
],
},
{
name: 'Projectors',
items: [
{
name: 'Projector Plus',
salesAmount: 99000,
},
{
name: 'Projector PlusHD',
salesAmount: 152250,
},
],
},
{
name: 'Televisions',
items: [
{
name: 'SuperLCD 55',
salesAmount: 147150,
},
{
name: 'SuperLCD 42',
salesAmount: 103200,
},
{
name: 'SuperLCD 70',
salesAmount: 56000,
},
{
name: 'SuperLED 42',
salesAmount: 159500,
},
{
name: 'SuperLED 50',
salesAmount: 233600,
},
{
name: 'SuperPlasma 50',
salesAmount: 184800,
},
{
name: 'SuperPlasma 65',
salesAmount: 178500,
},
],
},
{
name: 'Video Players',
items: [
{
name: 'HD Video Player',
salesAmount: 63690,
},
{
name: 'SuperHD Video Player',
salesAmount: 74000,
},
],
},
];
export const colorizationTypeLabel = { 'aria-label': 'Colorization Type' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.product {
font-weight: 500;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}

<dx-tree-map
[dataSource]="salesAmount"
title="Sales Amount by Product"
valueField="salesAmount"
[colorizer]="options"
>
<dxo-tree-map-tooltip
[enabled]="true"
format="currency"
[customizeTooltip]="customizeTooltip"
></dxo-tree-map-tooltip>
</dx-tree-map>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Colorization Type</span>
<dx-select-box
#selectbox
class="selectbox"
[items]="colorizationOptions"
[inputAttr]="{ 'aria-label': 'Colorization Option' }"
[width]="200"
[(value)]="options"
displayExpr="name"
valueExpr="options"
>
</dx-select-box>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxSelectBoxModule } from 'devextreme-angular';
import { DxTreeMapModule, DxTreeMapTypes } from 'devextreme-angular/ui/tree-map';
import { SalesAmount, Service } from './app.service';
interface ColorizationOption {
name: string;
options: {
type: DxTreeMapTypes.TreeMapColorizerType,
palette: string | string[],
colorizeGroups: boolean,
colorCodeField?: string,
range?: number[],
};
}
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
DxTreeMapModule,
DxSelectBoxModule,
],
})
export class AppComponent {
salesAmount: SalesAmount[];
options: ColorizationOption[ 'options' ];
colorizationOptions: ColorizationOption[] = [{
name: 'Discrete',
options: {
type: 'discrete',
palette: 'harmony light',
colorizeGroups: false,
},
}, {
name: 'Grouped',
options: {
type: 'discrete',
palette: 'harmony light',
colorizeGroups: true,
},
}, {
name: 'Range',
options: {
type: 'range',
palette: ['#fbd600', '#78299a'],
range: [0, 50000, 100000, 150000, 200000, 250000],
colorCodeField: 'salesAmount',
colorizeGroups: false,
},
}, {
name: 'Gradient',
options: {
type: 'gradient',
palette: ['#fbd600', '#78299a'],
range: [10000, 250000],
colorCodeField: 'salesAmount',
colorizeGroups: false,
},
}];
constructor(service: Service) {
this.salesAmount = service.getSalesAmount();
this.options = this.colorizationOptions[2].options;
}
customizeTooltip = ({ node, valueText }) => (
{
text: node.isLeaf()
? (`<span class='product'>${node.data.name}</span><br/>Sales Amount: ${valueText}`)
: null,
}
);
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .product {
font-weight: 500;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > span {
margin-right: 10px;
}
::ng-deep .option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
import { Injectable } from '@angular/core';
export interface SalesAmount {
name: string;
items: Record<string, unknown>[];
}
const salesAmount: SalesAmount[] = [{
name: 'Monitors',
items: [{
name: 'DesktopLCD 19',
salesAmount: 23420,
}, {
name: 'DesktopLCD 21',
salesAmount: 113900,
}, {
name: 'DesktopLED 19',
salesAmount: 49170,
}, {
name: 'DesktopLED 21',
salesAmount: 81200,
}],
}, {
name: 'Projectors',
items: [{
name: 'Projector Plus',
salesAmount: 99000,
}, {
name: 'Projector PlusHD',
salesAmount: 152250,
}],
}, {
name: 'Televisions',
items: [{
name: 'SuperLCD 55',
salesAmount: 147150,
}, {
name: 'SuperLCD 42',
salesAmount: 103200,
}, {
name: 'SuperLCD 70',
salesAmount: 56000,
}, {
name: 'SuperLED 42',
salesAmount: 159500,
}, {
name: 'SuperLED 50',
salesAmount: 233600,
}, {
name: 'SuperPlasma 50',
salesAmount: 184800,
}, {
name: 'SuperPlasma 65',
salesAmount: 178500,
}],
}, {
name: 'Video Players',
items: [{
name: 'HD Video Player',
salesAmount: 63690,
}, {
name: 'SuperHD Video Player',
salesAmount: 74000,
}],
}];
@Injectable()
export class Service {
getSalesAmount() {
return salesAmount;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.25/package.json',
'npm:devexpress-gantt@4.1.67/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.7"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div>
<DxTreeMap
id="treemap"
:data-source="salesAmount"
:colorizer="typeOptions"
value-field="salesAmount"
title="Sales Amount by Product"
>
<DxTooltip
:enabled="true"
:customize-tooltip="customizeTooltip"
format="currency"
/>
</DxTreeMap>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Colorization Type</span>
<DxSelectBox
:data-source="colorizationOptions"
:width="200"
:input-attr="{ 'aria-label': 'Colorization Type' }"
v-model:value="selectedType"
display-expr="name"
value-expr="name"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { computed, ref } from 'vue';
import DxTreeMap,
{
DxTooltip,
} from 'devextreme-vue/tree-map';
import { DxSelectBox } from 'devextreme-vue/select-box';
import { salesAmount, colorizationOptions } from './data.ts';
const selectedType = ref(colorizationOptions[2].name);
const typeOptions = computed(
() => colorizationOptions.find(({ name }) => name === selectedType.value)?.options || {},
);
const customizeTooltip = ({ node, node: { data: { name } }, valueText }: Record<string, any>) => (
{
text: node.isLeaf()
? `<span class='product'>${name}</span><br/>Sales Amount: ${valueText}`
: null,
}
);
</script>
<style scoped>
.product {
font-weight: 500;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > span {
margin-right: 14px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const colorizationOptions = [{
name: 'Discrete',
options: {
type: 'discrete',
palette: 'Harmony Light',
colorizeGroups: false,
},
}, {
name: 'Grouped',
options: {
type: 'discrete',
palette: 'Harmony Light',
colorizeGroups: true,
},
}, {
name: 'Range',
options: {
type: 'range',
palette: ['#fbd600', '#78299a'],
range: [0, 50000, 100000, 150000, 200000, 250000],
colorCodeField: 'salesAmount',
colorizeGroups: false,
},
}, {
name: 'Gradient',
options: {
type: 'gradient',
palette: ['#fbd600', '#78299a'],
range: [10000, 250000],
colorCodeField: 'salesAmount',
colorizeGroups: false,
},
}];
export const salesAmount = [{
name: 'Monitors',
items: [{
name: 'DesktopLCD 19',
salesAmount: 23420,
}, {
name: 'DesktopLCD 21',
salesAmount: 113900,
}, {
name: 'DesktopLED 19',
salesAmount: 49170,
}, {
name: 'DesktopLED 21',
salesAmount: 81200,
}],
}, {
name: 'Projectors',
items: [{
name: 'Projector Plus',
salesAmount: 99000,
}, {
name: 'Projector PlusHD',
salesAmount: 152250,
}],
}, {
name: 'Televisions',
items: [{
name: 'SuperLCD 55',
salesAmount: 147150,
}, {
name: 'SuperLCD 42',
salesAmount: 103200,
}, {
name: 'SuperLCD 70',
salesAmount: 56000,
}, {
name: 'SuperLED 42',
salesAmount: 159500,
}, {
name: 'SuperLED 50',
salesAmount: 233600,
}, {
name: 'SuperPlasma 50',
salesAmount: 184800,
}, {
name: 'SuperPlasma 65',
salesAmount: 178500,
}],
}, {
name: 'Video Players',
items: [{
name: 'HD Video Player',
salesAmount: 63690,
}, {
name: 'SuperHD Video Player',
salesAmount: 74000,
}],
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>